import signal
import sys

from scapy.sendrecv import sendp
from scapy.sendrecv import sniff
from scapy.layers.l2 import ARP

def gracefully_exit(sig, frame):
    print("Ctrl-C pressed. Exiting ...")
    sys.exit(0)

def usage(prog):
    # python arpphantom.py 10.1.1.3 08:00:27:08:0d:a1 enp0s9
    print("Usage: prog PHANTOM_HOST_IP PHANTOM_HW_ADDR NIC")

def main(argv):
    signal.signal(signal.SIGINT, gracefully_exit)
    if len(argv) < 4: 
        usage(argv[0])
        sys.exit(1)
    # host = '10.1.1.3'
    # nic = 'enp0s9'
    # hwaddr = '08:00:27:08:0d:a1'
    host = argv[1]
    hwaddr = argv[2]
    nic = argv[3]
    filter = 'arp dst host ' + host
    while True: 
        packets = sniff(filter=filter, count=1)
        arppkt = packets[0]
        arppkt.dst = arppkt.src
        arppkt.src = hwaddr
        arppkt.op = 2
        arppkt.hwdst = hwaddr
        arppkt.psrc = packets[0].pdst
        arppkt.hwsrc = packets[0].hwdst
        arppkt.hwdst = packets[0].hwsrc
        arppkt.pdst = packets[0].psrc
        sendp(arppkt, iface=nic, verbose=0)
        print(arppkt.summary())

if __name__ == "__main__":
    main(sys.argv)
